void memset(void *m,u8 b,u16 len) _naked
{
_asm
	ld hl,#2
	add hl,sp
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,(hl)
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)

	ex de,hl
	ld d,h
	ld e,l
	inc de
	dec bc
	ld (hl),a
	ldir

	ret
_endasm;
}



void memcpy(void *d,void *s,u16 len) _naked
{
_asm
	ld hl,#2
	add hl,sp
	push ix
	push hl
	pop ix
	ld e, +0 (ix)
	ld d, +1 (ix)
	ld l, +2 (ix)
	ld h, +3 (ix)
	ld c, +4 (ix)
	ld b, +5 (ix)
	ldir
	pop ix
	ret
_endasm;
}



void di(void) _naked
{
_asm
	di
	ret
_endasm;
}



void ei(void) _naked
{
_asm
	ei
	ret
_endasm;
}



void make_screen_table(u8 s) _naked
{
_asm
	ld hl,#2
	add hl,sp
	ld a,(hl)

	ld hl,#SCR_TABLE
	ld de,#0x5800
	or a
	jr z,.+4
	ld d,#SHADOW_SCR/256+24
	ld b,#24
0$:
	push bc
	ld (hl),e
	inc h
	ld (hl),d
	dec h
	inc l
	ex de,hl
	ld bc,#32
	add hl,bc
	ex de,hl
	pop bc
	djnz 0$

	ld hl,#SCR_TABLE+128
	ld de,#0x4000
	or a
	jr z,.+4
	ld d,#SHADOW_SCR/256
	ld b,#24
1$:
	ld (hl),d
	inc h
	ld (hl),e
	dec h
	inc l

    ld a,d		;based on DOWN_HL by Spencer Winsent
	add a,#8
	ld d,a
    ld a,e
    sub #0xe0
    ld e,a
    sbc a,a
    and #0xf8
    add a,d
    ld d,a

	djnz 1$
	ret
_endasm;
}



void cls_shadow(u8 w) _naked
{
_asm
	ld hl,#2
	add hl,sp
	ld b,(hl)

	ld hl,#SHADOW_SCR
	ld c,#192
	ld de,#32
	xor a
0$:
	push bc
	push hl
1$:
	ld (hl),a
	inc l
	djnz 1$
	pop hl
	add hl,de
	pop bc
	dec c
	jr nz,0$
	ret
_endasm;
}



void print(u8 x,u8 y,u8 c) _naked
{
_asm
	ld hl,#2
	add hl,sp
	ld b,(hl)	;x
	inc hl
	ld e,(hl)	;y
	inc hl
	ld c,(hl)	;c

	ex de,hl
	ld h,#SCR_TABLE/256
	ld a,(hl)
	add a,b
	ld e,a
	inc h
	ld d,(hl)
	set 7,l
	ld a,(hl)
	dec h
	ld h,(hl)
	add a,b
	ld l,a

	ld b,#TILES_ADR/256

	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	ld a,(bc)
	ld (de),a

	ret
_endasm;
}



void print_fld(void) _naked
{
_asm
	push ix

	ld ix,#_chr
	ld bc,#24*3
	add ix,bc
	ld hl,#0x4000
	ld de,#0x5800
	ld b,#24
1$:
	push bc
2$:
	ld b,#TILES_ADR/256
	ld c,(ix)
	inc ix

	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,(bc)
	ld (hl),a
	inc b
	ld a,h
	sub #7
	ld h,a
	inc l
	ld a,(bc)
	ld (de),a
	inc e

	ld a,l
	and #31
	cp #24
	jp c,2$

	ld a,l
	sub #24
	ld l,a

    ld a,h		;based on DOWN_HL by Spencer Winsent
	add a,#8
	ld h,a
    ld a,l
    sub #0xe0
    ld l,a
    sbc a,a
    and #0xf8
    add a,h
    ld h,a

	ld bc,#8
	ex de,hl
	add hl,bc
	ex de,hl

	pop bc
	djnz 1$

	pop ix
	ret
_endasm;
}



void draw_item(u8 x,u8 y,u8 type,u8 drop) _naked
{
_asm
	ld hl,#2
	add hl,sp

	ld c,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,(hl)

drawItemE:
	push bc
	push af

	or a
	jr z,0$
	ld a,(#_dropOff)
	ld d,a
	ld a,e
	sub d
	ld e,a
0$:
	ex de,hl
	ld h,#0
	add hl,hl
	add hl,hl
	add hl,hl
	ld d,h
	ld e,l
	add hl,hl
	add hl,de
	ld a,b
	ld b,#0
	add hl,bc
	ld bc,#_chr
	add hl,bc
	ex de,hl

	and #7
	ld c,a

	pop af
	or a
	jr z,1$
	ld a,(#_flashType)
	or a
	jr nz,1$
	ld a,(#_sparkFrame)
	cp #6
	jr nc,1$
	add a,#8
	ld c,a
1$:
	ld b,#0
	ld hl,#_tileList
	add hl,bc
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a

	ex de,hl

	ld a,c
	cp #8
	pop bc
	ld c,b
	ld b,#0
	jr nc,2$

	ld a,c
	and #0xf0
	ld c,a
	cp #2<<4
	ld a,(#_gemFrame)
	jr c,.+13
	ld a,c
	srl a
	srl a
	srl a
	srl a
	add a,#57
	ex af,af

	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	ld (hl),a
	ld a,c
	ld c,#22
	add hl,bc
	ld c,a
	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	ld a,c
	or a
	ld a,(de)
	inc de
	jr z,.+3
	ex af,af
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	ld (hl),a
	ld c,#22
	add hl,bc
	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	ld a,(de)
	ld (hl),a
	ret

2$:
	ld c,#255
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	ld c,#22
	add hl,bc
	ld c,#255
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	ld c,#22
	add hl,bc
	ld c,#255
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	cp c
	jr z,.+3
	ld (hl),a
	ret
_endasm;
}



void draw_field_items(void) _naked
{
_asm
	push ix
	push iy
	ld ix,#_fld
	ld iy,#_clr
	ld b,#3
0$:
	ld c,#0
1$:
	push bc
	ld e,b
	ld b,(ix)
	ld a,(iy)
	call drawItemE
	pop bc
	inc ix
	inc iy
	ld a,c
	add a,#3
	ld c,a
	cp #24
	jp nz,1$
	ld a,b
	add a,#3
	ld b,a
	cp #24+3+3
	jp nz,0$
	pop iy
	pop ix
	ret
_endasm;
}



void print2(u8 x,u8 y,u8 c) _naked
{
_asm
	ld hl,#2
	add hl,sp
	ld d,(hl)	;x
	inc hl
	ld e,(hl)	;y
	inc hl
	ld l,(hl)	;c

	ld h,#0
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,h
	add a,#SFONT_ADR/256
	ld h,a
	ld b,h
	ld c,l

	ex de,hl
	ld a,h
	ld h,#SCR_TABLE/256
	set 7,l
	ld d,(hl)
	inc h
	add a,(hl)
	ld e,a

	ld a,(bc)
	ld (de),a
	inc c
	inc d
	ld a,(bc)
	ld (de),a
	inc c
	inc d
	ld a,(bc)
	ld (de),a
	inc c
	inc d
	ld a,(bc)
	ld (de),a
	inc c
	inc d
	ld a,(bc)
	ld (de),a
	inc c
	inc d
	ld a,(bc)
	ld (de),a
	inc c
	inc d
	ld a,(bc)
	ld (de),a
	inc c
	inc d
	ld a,(bc)
	ld (de),a

	ret
_endasm;
}



void bonus_animation(void) _naked
{
_asm
	ld hl,#TILES_ADR+91
	ld de,#TILES_ADR+59
	ld c,#8
0$:
	push de
	push hl
	ld b,#4
1$:
	rlc (hl)
	ld a,(hl)
	and #0x7e
	ld (de),a
	inc e
	inc l
	djnz 1$
	pop hl
	pop de
	inc d
	inc h
	dec c
	jr nz,0$

	ld b,#4
2$:
	ld a,(de)
	ld c,(hl)
	ld (hl),a
	ld a,c
	ld (de),a
	inc e
	inc l
	djnz 2$

	ret
_endasm;
}



u8 rand8(void) _naked
{
_asm

;random number generator from some article

    ld a,#12
    ld d,a
    ld a,#34
    ld (.-4),a
    add a,d
    ld d,a
    ld a,#56
    ld (.-8),a
    add a,d
    rlca
    ld (.-6),a
	ld l,a
	ret
_endasm;
}



void randomize(void) _naked
{
_asm
	ld bc,(#23672)
	ld a,r
	xor b
	xor c
	ld b,a
1$:
	call _rand8
	djnz 1$

	ret
_endasm;
}



void set_interrupt(void) _naked
{
_asm
	di
	ld hl,#0xfe00
	ld de,#0xfe01
	ld bc,#0x0100
	ld a,h
	ld i,a
	inc a
	ld (hl),a
	ldir
	ld a,#0x18
	ld (#0xffff),a
	ld a,#0xc3
	ld (#0xfff4),a
	ld hl,#0$
	ld (#0xfff5),hl
	im 2
	ei
	ret

0$:
	push af
	push bc
	push de
	push hl
	ld b,#0
	ld de,#0x4647
	ld a,(#_timeEnable)
	or a
	jr z,1$
	ld hl,#_timeMs
	dec (hl)
	ld a,(hl)
	cp #25
	jr c,.+5
	ld de,#0x0000
	cp #255
	jr nz,1$
	ld (hl),#50
	ld b,#1
	ld hl,#_timeS
	dec (hl)
	ld a,(hl)
	cp #255
	jr nz,1$
	ld (hl),#59
	ld hl,#_timeM
	dec (hl)
	ld a,(hl)
	cp #10
	jr c,1$
	xor a
	ld (hl),a
	ld (#_timeS),a
1$:
	ld a,(#_timeEnable)
	or a
	jr z,.+10
	ld a,d
	ld (#0x59fb),a
	ld a,e
	ld (#0x5a1b),a

	ld hl,#_timeRedraw
	ld a,(hl)
	or b
	ld (hl),a
	ld a,(#_soundClock)
	or a
	jr z,3$
	ld hl,#_soundClockCnt
	ld a,(hl)
	inc a
	and #15
	ld (hl),a
	ld b,#16
	or a
	jr z,2$
	ld b,#4
	cp #8
	jr z,2$
	jp 3$
2$:
	ld a,#16
	out (#0xfe),a
	djnz .
	xor a
	out (#0xfe),a
3$:
	ld a,(#_timeEnable)
	or a
	jr z,4$
	ld a,(#_timeMs)
	and #4
	ld c,#7
	jr nz,.+4
	ld c,#64+7
	ld hl,#0x58d9
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
4$:
	pop hl
	pop de
	pop bc
	pop af
	ei
	ret

_endasm;
}



void vsync(void) _naked
{
_asm
	halt
	ret
_endasm;
}



void kempston_detect(void) _naked
{
_asm
	ld hl,#_kempstonEnabled
	ld b,#0
	ld (hl),b
0$:
	in a,(#31)
	and #0x1f
	or (hl)
	ld (hl),a
	djnz 0$
	or a
	ld (hl),#1
	ret z
	ld (hl),b
	ret
_endasm;
}



u8 poll_input(void) _naked
{
_asm
	ld l,#0

	ld bc,#0xbffe	;eLKJH
	in a,(c)
	rra
	jr c,.+4
	set 5,l

	ld b,#0xfe		;cZXCV
	in a,(c)
	rra
	jr c,10$		;caps is not pressed

;cursor joystick

	ld b,#0xf7		;12345
	in a,(c)
	and #0x10
	jr nz,.+4
	set 1,l
	ld b,#0xef		;09876
	in a,(c)
	rra
	jr c,.+4
	set 4,l
	rra
	rra
	jr c,.+4
	set 0,l
	rra
	jr c,.+4
	set 3,l
	rra
	jr c,.+4
	set 2,l
	ld b,#0x7f	;SpSymBNM
	in a,(c)
	cpl
	and #0x1f
	ret z
	set 4,l
	ret

;interface ii joysticks

10$:
	ld h,l
	ld b,#0xf7		;12345
	in a,(c)
	ld b,#5
	rra
	rl l
	djnz .-3
	ld b,#0xef		;09876
	in a,(c)
	and l
	ld l,h
	rra
	jr c,.+4
	set 4,l
	rra
	jr c,.+4
	set 3,l
	rra
	jr c,.+4
	set 2,l
	rra
	jr c,.+4
	set 0,l
	rra
	jr c,.+4
	set 1,l

	ld a,l
	or a
	ret nz

;keyboard QAOPM

	ld b,#0xfb	;QWERT
	in a,(c)
	rra
	jr c,.+4
	set 3,l
	ld b,#0xfd	;ASDFG
	in a,(c)
	rra
	jr c,.+4
	set 2,l
	ld b,#0xdf	;YUIOP
	in a,(c)
	rra
	jr c,.+4
	set 0,l
	rra
	jr c,.+4
	set 1,l
	ld b,#0x7f	;SpSymBNM
	in a,(c)
	cpl
	and #0x1f
	jr z,.+4
	set 4,l

	ld a,l
	or a
	ret nz

;kempston

	ld a,(#_kempstonEnabled)
	or a
	ret z

	in a,(#31)
	and #0x1f
	ld l,a

	ret

_endasm;
}



void bb_depack(const u8 *data,u16 dst) _naked
{
_asm

;BitBuster depacker, originally by Arjan Bakker

	ld hl,#2
	add hl,sp
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld h,b
	ld l,c

bb_depack_e:

	di
	inc hl
	inc hl
	inc hl
	inc hl

	ld a,#128
	exx
	ld de,#1
	exx

depack_loop:
	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi
	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi
	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi
	jp depack_loop

output_compressed:
	ld c,(hl)
	inc	hl

output_match:
	ld b,#0
	bit	7,c
	jr z,output_match1

	call GET_BIT_FROM_BITSTREAM
	rl b
	call GET_BIT_FROM_BITSTREAM
	rl b
	call GET_BIT_FROM_BITSTREAM
	rl b
	call GET_BIT_FROM_BITSTREAM

	jp c,output_match1
	res	7,c

output_match1:
	inc	bc
	exx
	ld h,d
	ld l,e
	ld b,e

get_gamma_value_size:
	exx
	call GET_BIT_FROM_BITSTREAM
	exx
	jr nc,get_gamma_value_size_end
	inc	b
	jp get_gamma_value_size

get_gamma_value_bits:
	exx
	call GET_BIT_FROM_BITSTREAM
	exx
	adc	hl,hl

get_gamma_value_size_end:
	djnz get_gamma_value_bits

get_gamma_value_end:
	inc	hl
	exx
	jp c,bb_exit
	push hl
	exx
	push hl
	exx
	ld h,d
	ld l,e
	sbc	hl,bc
	pop	bc
	ldir
	pop	hl

	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi
	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi

	jp depack_loop

GET_BIT_FROM_BITSTREAM:
	add	a,a
	ret nz
	ld a,(hl)
	inc	hl
	rla
	ret

bb_exit:
	ei
	ret

_endasm;
}



void music_play(u8 i) _naked
{
_asm
	ld hl,#MUSIC_PCK
	ld de,#MUSIC_ADR
	call bb_depack_e

	ld hl,#2
	add hl,sp

	push ix
	ld a,(#_kempstonEnabled)
	ld c,a
	ld a,(hl)
	or a
	ld ix,#0
	jr nz,0$
	ld ix,#1$
0$:
	di
	call MUSIC_ADR
	ei
	pop ix
	ret

1$:
	ld hl,#_timeMs
	inc (hl)
	ld a,(hl)
	and #7
	ld bc,#0x0747
	jp z,2$
	cp #4
	ld bc,#0x0141
	jp z,2$
	ret
2$:
	ld hl,#0x5a4b
	ld (hl),b
	inc l
	ld (hl),b
	inc l
	ld (hl),b
	inc l
	ld (hl),b
	inc l
	ld (hl),b
	inc l
	inc l
	ld (hl),b
	inc l
	ld (hl),b
	inc l
	ld (hl),b
	inc l
	ld (hl),b
	ld hl,#0x5a6b
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	inc l
	ld (hl),c
	ret

_endasm;
}



void sfx_grip(u8 h) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	ld hl,#2
	add hl,sp

	di
	ld a,(hl)
	or a
	ld b,#50
	jr nz,.+4
	ld b,#10
	ld c,b
	ld hl,#0
	ld de,#0x1020
0$:
	ld a,(hl)
	and d
	out (#0xfe),a
	inc hl
	ld a,e
	dec a
	jr nz,.-1
	djnz 0$
	ld b,c
1$:
	ld a,(hl)
	and d
	out (#0xfe),a
	inc hl
	ld a,#4
	dec a
	jr nz,.-1
	xor a
	out (#0xfe),a
	ld a,e
	dec a
	jr nz,.-1
	djnz 1$
	ei
	ret
_endasm;
}



void sfx_exchange(u8 d) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	ld hl,#2
	add hl,sp

	di
	ld a,(hl)
	or a
	jr nz,0$
	ld bc,#20*256+150
	ld e,#-2
	jr 1$
0$:
	ld bc,#20*256+100
	ld e,#4
1$:
	ld a,#16
	out (#0xfe),a
	ld a,b
	inc a
	dec a
	jr nz,.-1
	out (#0xfe),a
	ld a,c
	dec a
	jr nz,.-1
	ld a,c
	add a,e
	ld c,a
	djnz 1$
	ei
	ret
_endasm;
}



void sfx_match(u16 f,u8 d) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	ld hl,#2
	add hl,sp
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld c,(hl)

	di
	push ix
	ld ix,#0
	push de
	call 0$
	pop hl
	ld de,#200
	add hl,de
	ex de,hl
	call 0$
	pop ix
	ei
	ret

0$:
	ld hl,#1000
1$:
	add ix,de
	ld b,#1
	jr nc,2$
	ld a,#16
	out (#0xfe),a
	ld b,c
	djnz .
	xor a
	out (#0xfe),a
	ld a,#101
	sub c
	ld b,a
2$:
	djnz .
	dec hl
	ld a,h
	or l
	jr nz,1$
	ret
_endasm;
}



void sfx_hint(void) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	di
	ld b,#100
	xor a
0$:
	xor #16
	out (#0xfe),a
	ld c,#20
	dec c
	jr nz,.-1
	djnz 0$
	ei
	ret
_endasm;
}



void sfx_select(void) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	di
	ld b,#4
	ld d,#128
0$:
	push bc
	ld bc,#3*256+200
1$:
	push bc
	ld b,#20
2$:
	xor #16
	and #16
	out (#0xfe),a
	ld e,a
	ld a,d
	dec a
	jr nz,.-1
	out (#0xfe),a
	ld a,#129
	sub d
	dec a
	jr nz,.-1
	ld a,e
	ld e,c
	dec e
	jr nz,.-1
	djnz 2$
	pop bc
	ld a,c
	sub #16
	ld c,a
	djnz 1$
	pop bc
	srl d
	srl d
	djnz 0$
	ei
	ret
_endasm;
}



void sfx_start(void) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	di
	ld a,#100
	call 0$
	ld a,#5
	call 0$
	ld a,#20
	call 0$
	ld a,#2
	call 0$
	ei
	ret

0$:
	ld bc,#2*256+16
	ld hl,#800
	ex af,af
1$:
	push bc
2$:
	ld a,#16
	out (#0xfe),a
	ex af,af
	ld b,a
	ex af,af
	djnz .
	xor a
	out (#0xfe),a
	ld d,h
	ld e,l
	dec e
	jr nz,.-1
	dec d
	jr nz,.-4
	dec c
	jr nz,2$
	ld de,#-10
	add hl,de
	pop bc
	djnz 1$
	ret
_endasm;
}



void sfx_nomoves(u16 d) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	ld hl,#2
	add hl,sp
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	push hl
	push hl

	di
	ld hl,#0
	pop de
	exx
	pop hl
	ld de,#10
	add hl,de
	ex de,hl
	ld hl,#0
	ld bc,#2000
	xor a
0$:
	push bc
	out (#0xfe),a
	add hl,de
	jr nc,.+4
	xor #16
	exx
	add hl,de
	jr nc,.+4
	xor #16
	exx
	pop bc
	dec c
	jr nz,0$
	djnz 0$
	ei
	ret
_endasm;
}



void sfx_gem(void) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	di
	xor a
	ld c,#50
0$:
	out (#0xfe),a
	xor #16
	ld b,#100
	djnz .
	dec c
	jr nz,0$
	ld c,#50
1$:
	ld a,#16
	out (#0xfe),a
	ld b,#100
	djnz .
	ld a,#0
	out (#0xfe),a
	ld b,#100
	djnz .
	dec c
	jr nz,1$
	ld c,#50
2$:
	ld a,#16
	out (#0xfe),a
	ld b,#10
	djnz .
	ld a,#0
	out (#0xfe),a
	ld b,#190
	djnz .
	dec c
	jr nz,2$
	ei
	ret
_endasm;
}



void sfx_drop(void) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	di
	ld b,#25
	ld c,#20
	xor a
0$:
	out (#0xfe),a
	xor #16
	ld d,a
	ld e,c
	ld a,#10
	dec a
	jr nz,.-1
	out (#0xfe),a
	dec e
	jp .+3
	jp .+3
	jp .+3
	jr nz,.-10
	ld a,c
	add a,#5
	ld c,a
	ld a,d
	djnz 0$
	ei
	ret
_endasm;
}



void sfx_bonus(u16 c) _naked
{
_asm
	ld hl,#2
	add hl,sp
	ld e,(hl)
	inc hl
	ld d,(hl)

	ld a,(_soundEnable)
	or a
	ret z

	di
	push ix
	ld ix,#0
	ld b,#3
	ld c,#100
0$:
	ld hl,#1000
	call 1$
	push de
	ld de,#1000
	call 1$
	pop de
	ld a,c
	sub #30
	ld c,a
	ld hl,#500
	add hl,de
	ex de,hl
	djnz 0$
	pop ix
	ei
	ret

1$:
	push bc
	push de
	push hl
2$:
	add ix,de
	ld b,#1
	jr nc,3$
	ld a,#16
	out (#0xfe),a
	ld b,c
	djnz .
	xor a
	out (#0xfe),a
	ld a,#101
	sub c
	ld b,a
3$:
	djnz .
	dec hl
	ld a,h
	or l
	jr nz,2$
	pop hl
	pop de
	pop bc
	ret
_endasm;
}



void sfx_explode(void) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	di
	ld hl,#0
	ld b,#50
	ld e,#1
0$:
	ld a,(hl)
	ld c,a
	and #16
	out (#0xfe),a
	dec c
	jr nz,.-1
	ld c,b
	dec c
	jr nz,.-1
	xor a
	out (#0xfe),a
	ld c,e
	dec c
	jr nz,.-1
	inc e
	inc hl
	djnz 0$
	ei
	ret
_endasm;
}



void sfx_score(void) _naked
{
_asm
	ld a,(_soundEnable)
	or a
	ret z

	di
	ld e,#25
	ld c,#1
0$:
	ld a,#16
	out (#0xfe),a
	ld b,#10
	djnz .
	xor a
	out (#0xfe),a
	ld b,c
	djnz .
	inc c
	inc c
	dec e
	jr nz,0$
	ei
	ret
_endasm;
}



void screen_change(u8 w,u8 a) _naked
{
_asm
	ld hl,#2
	add hl,sp
	ld c,(hl)
	inc hl
	ld a,(hl)

	di
	or a
	jr z,0$
	push bc
	ld hl,#SHADOW_SCR+6144
	ld de,#0x5800
	ld bc,#0x0300
	ldir
	pop bc
0$:

	ld b,c
	ld a,#33
	sub c
	ld c,a
	ld a,b
	srl a
	srl a
	srl a
	ld b,#8
1$:
	;halt
	push bc
	ld hl,#SHADOW_SCR
	ld de,#0x4000
	ld b,#192
2$:
	push bc
	ld b,a
	bit 0,h
	jr z,4$
3$:
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	djnz 3$
	jr 5$
4$:
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	djnz 4$
5$:
	dec l
	add hl,bc
	ex de,hl
	dec l
	add hl,bc
	ex de,hl
	pop bc
	dec b
	jp nz,2$
	pop bc
	dec b
	jp nz,1$

	ei
	ret
_endasm;
}



void colorbar_effect(void) _naked
{
_asm
	push ix
	ld hl,#22528+32*23
	ld de,#22528+32*27
	ld ix,#SHADOW_SCR+6144+32*27
	ld b,#28
0$:
	halt
	push bc
	push de
	push hl
	push ix

	ld b,#32
	ld a,h
	cp #0x58
	jr c,2$
1$:
	ld a,(hl)
	and #64
	or #7
	ld (hl),a
	inc l
	djnz 1$

	ld a,d
	cp #0x5b
	jr nc,3$

	ld b,#32
2$:
	ld a,(ix)
	ld (de),a
	inc e
	inc ix
	djnz 2$

3$:
	pop ix
	pop hl
	pop de
	ld bc,#-32
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	add ix,bc
	pop bc
	djnz 0$
	pop ix
	ret
_endasm;
}



void char_scroll(u8 x,u8 y,u8 d) _naked
{
_asm
	ld hl,#2
	add hl,sp
	ld d,(hl)	;x
	inc hl
	ld e,(hl)	;y
	inc hl
	ld c,(hl)	;d

	ex de,hl
	ld a,h
	ld h,#SCR_TABLE/256
	set 7,l
	ld d,(hl)
	inc h
	add a,(hl)
	ld e,a
	ex de,hl

	ld a,c
	or a
	ret z

	push ix

	cp #128
	jr nc,2$

	ld d,h
	ld e,l
	inc d
	push hl
	push de
	ld b,#7
0$:
	ld a,(de)
	ld (hl),a
	inc h
	inc d
	djnz 0$
	push hl
	pop ix
	ld c,#32
	pop de
	ex de,hl
	add hl,bc
	ex de,hl
	pop hl
	add hl,bc
	ld a,(hl)
	ld (ix),a
	ld b,#7
1$:
	ld a,(de)
	ld (hl),a
	inc h
	inc d
	djnz 1$
	pop ix
	ret

2$:
	ld bc,#256*6+32
	add hl,bc
	ld d,h
	ld e,l
	inc h
	push hl
	push de
	ld b,#7
3$:
	ld a,(de)
	ld (hl),a
	dec d
	dec h
	djnz 3$
	push hl
	pop ix
	pop de
	pop hl
	ld bc,#-32
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	ld a,(hl)
	ld (ix),a
	ld b,#7
4$:
	ld a,(de)
	ld (hl),a
	dec d
	dec h
	djnz 4$
	pop ix
	ret
_endasm;
}



void darken_playfield(void) _naked
{
_asm
	ld hl,#22528
	ld bc,#24*256+24
	ld de,#32
0$:
	push bc
	push hl
1$:
	res 6,(hl)
	inc l
	djnz 1$
	pop hl
	add hl,de
	pop bc
	dec c
	jr nz,0$

	ld hl,#16384
	ld de,#22528-32
	ld b,#192/2
2$:
	ld a,b
	and #3
	jr nz,.+3
	halt
	push bc
	push de
	push hl
	ld b,#24
3$:
	ld a,(hl)
	and #0xaa
	ld (hl),a
	inc l
	djnz 3$
	ex de,hl
	ld b,#24
4$:
	ld a,(hl)
	and #0x55
	ld (hl),a
	inc l
	djnz 4$
	pop hl
	pop de
	ld b,#2
5$:
	inc h		;DOWN_HL, UP_DE by Spencer Winsent
	ld a,h
	and #7
	jr nz,.+11
	ld a,l
	sub #0xe0
	ld l,a
	sbc a,a
	and #0xf8
	add a,h
	ld h,a
	ld a,d
	dec d
	and #7
	jr nz,.+11
	ld a,e
	add a,#0xe0
	ld e,a
	sbc a,a
	and #8
	add a,d
	ld d,a
	djnz 5$
	pop bc
	djnz 2$
	ret
_endasm;
}