PATH=e:\sdcc\bin;tools\

rem PACK RESOURCES

pack title.scr
pack panel.scr
pack welldone.scr
pack music.bin

rem COMPILE C

as-z80 -o crt0.o crt0.s
sdcc -mz80 --code-loc 0x800a --data-loc 0 --no-std-crt0 crt0.o main.c --opt-code-speed -o out.ihx

rem MAKE SNAPSHOT

hex2bin out.ihx
bin2sna sna.diz

rem GET CODE FROM THE SNAPSHOT

sna2bin test.sna

rem PACK THE CODE

hrust13 -depacker -di -start 25088 -depackto 25088 -jp 32768 -dadr 23296 code.bin code.hrs
del code.bin

rem MAKE TAPE VERSION

bin2tap code.hrs
bin2tap screen.bin
copy /b loader.tap+screen.tap+code.tap magic_tokens.tap
del screen.tap
del code.tap

rem MAKE SCL VERSION

copy screen.bin mgtokscr.c
ren code.hrs mgtokcod.c
del magic_tokens.scl
trdtool # magic_tokens.scl
trdtool + magic_tokens.scl loader.$b mgtokscr.c mgtokcod.c

rem DELETE TEMPORARY FILES

del out.bin
del mgtokscr.c
del mgtokcod.c
del *.z80
del *.sym
del *.o
del *.map
del *.lst
del *.lnk
del *.asm
del *.rel
del *.ihx
del *.pck

rem RUN THE SNAPSHOT
rem test.sna
del test.sna