#pragma disable_warning 85


#define u8 unsigned char
#define i8 signed char
#define u16 unsigned int
#define i16 signed int
#define u32 unsigned long
#define i32 signed long

#define TRUE	1
#define FALSE	0

#define SCR_TABLE		0xfc00
#define TILES_ADR		0xf300
#define SFONT_ADR		0xf000
#define MUSIC_ADR		0xdd00
#define SHADOW_SCR		0xd500
#define MUSIC_PCK		0x7700
#define WELLDONE_PCK	0x7200
#define PANEL_PCK		0x6f00
#define TITLE_PCK		0x6200

#define RIGHT	1
#define LEFT	2
#define DOWN	4
#define UP		8
#define FIRE	16
#define MENU	32

u8 kempstonEnabled;

#include "asmfunc.h"

u8 fld[8*9];
u8 clr[8*9];
u8 clrn[8*9];
u8 fldinit[8*8];
u8 fldchk[8*8];
u8 fldpcol[8];
u8 chr[24*24+6*24];

i8 curX,curY,curDX,curDY,curEX,curEY;
u8 curAnim,curMove,curCol;
u8 exchSrcOff,exchDstOff;
u8 exchSrcItem,exchDstItem;
u8 exchDirM;
u8 mode;
u8 combo;
u8 dropOff;
i8 sparkFrame;
u8 gemFrame;
u8 fldInitPtr;
u8 fldInit;
u8 difficulty;

u8 hintAX,hintAY;
u8 hintBX,hintBY;
u8 hintAnim;
u16 hintCnt;
u16 hintTime;

u32 score;
u8 level;
u8 timeM;
i8 timeS;
u8 timeMs;
u8 restarts;
u8 timeEnable;
u8 timeRedraw;
u8 showPanel;

u8 itemTypes;
u8 itemCnt;
u8 gemsTotal;
u8 gemsFreq;
u8 gemsScreenMax;
u8 gemsScreenCnt;

u8 soundEnable;
u8 soundClock;
u8 soundClockCnt;

u8 frameCnt;
u8 msgDelay;
u8 dropAllCnt;
u8 flashType;
u8 flashCnt;

u16 levItems;
u8 levCombo;
u16 levBonuses;
u16 totalItems;
u8 totalCombo;
u16 totalBonuses;

u8 bonusActive;
u8 bonusTimeCnt;
u8 bonusExplodeCnt;
u8 bonusColorCnt;
u8 bonusCollectCnt;

#define MODE_CURMOVE	0
#define MODE_CURHOLD	1
#define MODE_EXCHANGE	2
#define MODE_CLEARLINES	3
#define MODE_DROPITEMS	4
#define MODE_DROPALL	5

#define STAT_SCORE		1
#define STAT_LEVEL		2
#define STAT_TIME		4
#define STAT_GEMS		8

#define DONE_CLEAR		1
#define DONE_TIMEOUT	2
#define DONE_RESTART	3
#define DONE_QUIT		4

#define PAGE_TITLE		1
#define PAGE_GAME		2
#define PAGE_CLEAR		3

#define ITEM_GEM		1
#define ITEM_TIME		2
#define ITEM_EXPLODE	3
#define ITEM_COLOR		4
#define ITEM_COLLECT	5

#define BONUS_TIME		1
#define BONUS_EXPLODE	2
#define BONUS_COLOR		4
#define BONUS_COLLECT	8

const u8 tileEmpty[9]={32,32,32,32,32,32,32,32,32};
const u8 tileTypeA[9]={96,97,98,128,129,130,160,161,162};
const u8 tileTypeB[9]={99,100,101,131,132,133,163,164,165};
const u8 tileTypeC[9]={102,103,104,134,135,136,166,167,168};
const u8 tileTypeD[9]={105,106,107,137,138,139,169,170,171};
const u8 tileTypeE[9]={108,109,110,140,141,142,172,173,174};
const u8 tileTypeF[9]={111,112,113,143,144,145,175,176,177};
const u8 tileTypeG[9]={114,115,116,146,147,148,178,179,180};
const u8 tileSpark1[9]={255,255,255,255,117,255,255,255,255};
const u8 tileSpark2[9]={255,118,255,119,120,121,255,122,255};
const u8 tileSpark3[9]={123,124,125,126,127,149,150,151,152};
const u8 tileSpark4[9]={153,154,155,156,32,157,158,159,181};
const u8 tileSpark5[9]={182,32,183,32,32,32,184,32,185};
const u8 tileSpark6[9]={186,32,187,32,32,32,188,32,189};

const u8 *tileList[]={
	tileEmpty,
	tileTypeA,
	tileTypeB,
	tileTypeC,
	tileTypeD,
	tileTypeE,
	tileTypeF,
	tileTypeG,
	tileSpark1,
	tileSpark2,
	tileSpark3,
	tileSpark4,
	tileSpark5,
	tileSpark6
};

const u8 msgLevel[]={202,203,204,203,202,0,234,235,236,235,234,0};
const u8 msgTimeOut[]={205,206,207,203,32,208,209,205,32,212,0,237,238,239,235,32,240,241,237,32,244,0};
const u8 msgNoMoves[]={210,208,32,207,208,204,203,211,32,212,0,242,240,32,239,240,236,235,243,32,244,0};
const u8 msgGameOver[]={213,214,207,203,32,208,204,203,215,212,0,245,246,239,235,32,240,236,235,247,244,0};
const u8 msgLevelClear[]={202,203,204,203,202,32,216,202,203,214,215,212,0,234,235,236,235,234,32,248,234,235,246,247,244,0};

const u8 msgBonusTime[]={0,25,26,27,28,0,255};
const u8 msgBonusExplode[]={29,30,31,32,33,34,255};
const u8 msgBonusColor[]={35,36,37,38,39,40,255};
const u8 msgBonusCollect[]={41,42,43,44,45,46,255};

//number of types, minutes, seconds, gems total, gems frequency, gems on screen, hint delay, bonuses enabled
const u8 levData[]={
4,1,10,10,10,5,10,0,
4,1,20,15,10,5,20,0,
5,1,40,20,9,6,30,BONUS_EXPLODE,
5,2,0,25,9,6,40,BONUS_EXPLODE,
5,1,0,30,8,7,50,BONUS_EXPLODE|BONUS_TIME,
6,2,0,40,8,7,60,BONUS_EXPLODE|BONUS_TIME,
6,2,15,50,7,8,70,BONUS_EXPLODE|BONUS_TIME|BONUS_COLOR,
6,2,30,60,7,9,80,BONUS_EXPLODE|BONUS_TIME|BONUS_COLOR,
10,2,30,70,6,12,90,BONUS_EXPLODE|BONUS_TIME|BONUS_COLOR|BONUS_COLLECT,
9,2,0,80,5,14,100,BONUS_EXPLODE|BONUS_TIME|BONUS_COLOR|BONUS_COLLECT
};



void wait_button(void)
{
	while(1)
	{
		vsync();
		if(poll_input()&FIRE) return;
	}
}



void printstr(u8 x,u8 y,i8 *str)
{
	u8 c;

	while(1)
	{
		c=*str++;
		if(!c) return;
		print(x,y,c);
		x++;
	}
}



void printnum16(u8 x,u8 y,u16 num)
{
	u8 i,n;

	if(!num) print(x,y,'0');

	while(num)
	{
		print(x,y,(num%10)+'0');
		x--;
		num=num/10;
	}
}


void printlargenum16(u8 x,u8 y,u16 num,u8 len)
{
	u8 i,c;

	x=x+len-1;

	for(i=0;i<len;i++)
	{
		c=(num%10)+192;
		print(x,y,c);
		print(x,y+1,c+32);
		x--;
		num=num/10;
	}
}


void printlargenum32(u8 x,u8 y,u32 num,u8 len)
{
	u8 i,c;

	x=x+len-1;

	for(i=0;i<len;i++)
	{
		c=(num%10)+192;
		print(x,y,c);
		print(x,y+1,c+32);
		x--;
		num=num/10;
	}
}


void printlargetext(u8 x,u8 y,const u8 *msg)
{
	u8 xs,c;

	xs=x;

	while(1)
	{
		c=*msg++;
		if(!c) break;
		if(c!=32) print(x,y,c);
		x++;
	}

	x=xs;
	y++;

	while(1)
	{
		c=*msg++;
		if(!c) break;
		if(c!=32) print(x,y,c);
		x++;
	}
}



void print2str(u8 x,u8 y,const u8 *msg)
{
	u8 c;

	while(1)
	{
		c=*msg++;
		if(c==255) break;
		print2(x++,y,c);
	}
}



void draw_gamestats(u8 i)
{
	if(i&STAT_SCORE) printlargenum32(25,4,score,6);
	if(i&STAT_LEVEL) printlargenum16(27,10,level,2);
	if(i&STAT_TIME)
	{
		if(!soundClock||(soundClock&&frameCnt&8))
		{
			printlargenum16(26,15,timeM,1);
			printlargenum16(28,15,timeS,2);
		}
		else
		{
			print(26,15,32);
			print(26,16,32);
			print(28,15,32);
			print(28,16,32);
			print(29,15,32);
			print(29,16,32);
		}
	}
	if(i&STAT_GEMS) printlargenum16(27,20,gemsTotal,2);
}



void draw_message(u8 i)
{
	switch(i)
	{
	case 0:
		for(i=25;i<31;i++) print2(i,6,0);
		break;
	case 252:
		print2str(25,6,msgBonusTime);
		break;
	case 253:
		print2str(25,6,msgBonusExplode);
		break;
	case 254:
		print2str(25,6,msgBonusColor);
		break;
	case 255:
		print2str(25,6,msgBonusCollect);
		break;
	default:
		print2(25,6,1);
		print2(26,6,2);
		print2(27,6,3);
		print2(28,6,i>9?i/10+5:0);
		print2(29,6,i%10+15);
		print2(30,6,4);
	}
	msgDelay=20;
}



void draw_flash_stat(u8 x,u8 y,u8 c)
{
	u8 *atr;
	u8 i,c1,c2;

	atr=(u8*)22528+y*32+x;

	if(c&1)
	{
		c1=6+64;
		c2=7+64;
	}
	else
	{
		c1=4;
		c2=4+64;
	}

	for(i=0;i<6;i++)
	{
		*(atr+i)=c1;
		*(atr+32+i)=c2;
	}
}



void draw_gems_out(void)
{
	const u8 anim[6]={217,218,219,249,250,251};
	u8 i,j,n,ptr;

	for(n=0;n<6;n++)
	{
		for(i=0;i<3;i++) vsync();
		ptr=0;

		for(i=1;i<25;i+=3)
		{
			for(j=1;j<25;j+=3)
			{
				if(fld[ptr++]>>4==ITEM_GEM)
				{
					print(j,i,anim[n]);
				}
			}
		}
	}
}



u8 generate_item(void)
{
	u8 i;

	if(!fldInit&&fldInitPtr<8*8)
	{
		return fldinit[fldInitPtr++];
	}

	i=1+(rand8()%itemTypes);
	if(i>7) i=7;
	itemCnt++;

	if(!fldInit)
	{
		if(bonusTimeCnt>0)
		{
			i|=ITEM_TIME<<4;
			bonusTimeCnt--;
			return i;
		}
		if(bonusExplodeCnt>0)
		{
			i|=ITEM_EXPLODE<<4;
			bonusExplodeCnt--;
			return i;
		}
		if(bonusColorCnt>0)
		{
			i|=ITEM_COLOR<<4;
			bonusColorCnt--;
			return i;
		}
		if(bonusCollectCnt>0)
		{
			i|=ITEM_COLLECT<<4;
			bonusCollectCnt--;
			return i;
		}
		if(itemCnt>=gemsFreq)
		{
			if(gemsScreenCnt<gemsScreenMax&&gemsTotal>gemsScreenCnt)
			{
				i|=ITEM_GEM<<4;
				itemCnt=0;
				gemsScreenCnt++;
			}
		}
	}

	return i;
}



void score_add(u16 s)
{
	score+=s;
}



void combo_increment(void)
{
	combo++;
	if(combo==6&&(bonusActive&BONUS_COLLECT)) bonusCollectCnt++;
	if(combo==5&&(bonusActive&BONUS_COLOR))   bonusColorCnt++;
	if(combo==4&&(bonusActive&BONUS_TIME))    bonusTimeCnt++;
	if(combo==3&&(bonusActive&BONUS_EXPLODE)) bonusExplodeCnt++;
}



u8 find_lines(void)//find 3+ lines and mark them with clr, return TRUE if any found
{
	u8 i,j,pp;
	u8 t,c,cnt;

	for(i=0;i<8*8;i++) clr[i]=0;

	pp=0;
	c=FALSE;

	for(i=0;i<8;i++)
	{
		pp=i*8;
		t=255;
		cnt=1;
		for(j=0;j<9;j++)
		{
			if((fld[pp]&7)!=t||j==8)
			{
				if(cnt>2)
				{
					while(cnt>0)
					{
						clr[pp-cnt]=1;
						cnt--;
					}
					c=TRUE;
				}
				t=fld[pp]&7;
				cnt=1;
			}
			else
			{
				cnt++;
			}
			pp++;
		}
	}

	for(i=0;i<8;i++)
	{
		pp=i;
		t=255;
		cnt=1;
		for(j=0;j<9;j++)
		{
			if((fld[pp]&7)!=t||j==8)
			{
				if(cnt>2)
				{
					cnt=cnt*8;
					while(cnt>0)
					{
						clr[pp-cnt]=1;
						cnt-=8;
					}
					c=TRUE;
				}
				t=fld[pp]&7;
				cnt=1;
			}
			else
			{
				cnt++;
			}
			pp+=8;
		}
	}

	return c;
}



u8 bonus_explode(u8 off)
{
	u8 i,j,x,y,ptr,c;

	c=0;
	y=(off>>3)-1;

	for(i=0;i<3;i++)
	{
		x=(off&7)-1;
		for(j=0;j<3;j++)
		{
			if(x<8&&y<8&&!(i==1&&j==1))
			{
				ptr=(y<<3)+x;
				if(fld[ptr]&&!clr[ptr])
				{
					clrn[ptr]=1;
					c++;
				}
			}
			x++;
		}
		y++;
	}

	combo_increment();

	return c;
}



u8 bonus_color(u8 t)
{
	u8 i,c;

	c=0;

	for(i=0;i<8*8;i++)
	{
		if(fld[i]&&!clr[i])
		{
			if((fld[i]&7)==t)
			{
				clrn[i]=1;
				c++;
			}
		}
	}

	return c;
}



void bonus_collect(void)
{
	u8 i,gemc;

	draw_gems_out();

	gemc=0;

	for(i=0;i<8*8;i++)
	{
		if((fld[i]>>4)==ITEM_GEM)
		{
			fld[i]&=0x0f;
			gemsTotal--;
			gemc++;
		}
	}

	if(gemc)
	{
		for(i=0;i<(gemsTotal?1:5);i++) sfx_gem();
	}
}



u8 clear_lines(void)
{
	u8 i,j;
	u8 c,gemc;
	u8 sGem,sTime,sExplode,sColor,sCollect;

	c=0;
	gemc=0;
	sGem=FALSE;
	sTime=FALSE;
	sExplode=FALSE;
	sColor=FALSE;
	sCollect=FALSE;

	for(i=0;i<8*8;i++)
	{
		if(clr[i])
		{
			switch(fld[i]>>4)
			{
			case ITEM_GEM:
				gemsTotal--;
				gemc++;
				sGem=TRUE;
				break;
			case ITEM_TIME:
				di();
				timeS+=20;
				if(timeS>=60)
				{
					timeS-=60;
					if(timeM<9) timeM++;
				}
				if(!(timeM==0&&timeS<20)) soundClock=FALSE;
				ei();
				sTime=TRUE;
				break;
			case ITEM_EXPLODE:
				sExplode=TRUE;
				break;
			case ITEM_COLOR:
				flashType|=1<<((fld[i]&0x0f)-1);
				sColor=TRUE;
				break;
			case ITEM_COLLECT:
				sCollect=TRUE;
				break;
			}
			c++;
		}
	}

	if(sGem)
	{
		if(gemsTotal)
		{
			sfx_gem();
		}
		else
		{
			draw_gamestats(STAT_GEMS);
			for(i=0;i<5;i++)
			{
				vsync();
				draw_flash_stat(25,20,i);
				sfx_gem();
			}
			draw_gamestats(STAT_GEMS);
		}
	}
	if(sTime)
	{
		sfx_bonus(200);
		draw_message(252);
		draw_gamestats(STAT_TIME);
		for(i=0;i<10;i++)
		{
			for(j=0;j<3;j++) vsync();
			draw_flash_stat(25,15,i);
		}
		draw_gamestats(STAT_TIME);
	}
	if(sExplode)
	{
		sfx_explode();
		draw_message(253);
	}
	if(sColor)
	{
		flashCnt=3;
		sfx_bonus(500);
		draw_message(254);
	}
	if(sCollect)
	{
		flashType=128;
		flashCnt=3;
		sfx_bonus(1000);
		draw_message(255);
	}

	levItems+=c;

	score_add(c);
	mode=MODE_CLEARLINES;
	sparkFrame=0;

	return c;
}



void remove_lines_pre(void)
{
	u8 i;

	for(i=0;i<8*8;i++)
	{
		if(clr[i])
		{
			switch(fld[i]>>4)
			{
			case ITEM_COLLECT:
				bonus_collect();
				levBonuses++;
				draw_gamestats(STAT_GEMS);
				break;
			}
		}
	}

	return;
}



u8 remove_lines(void)
{
	u8 i,re;

	memset(clrn,0,8*8);
	re=FALSE;

	for(i=0;i<8*8;i++)
	{
		if(clr[i])
		{
			switch(fld[i]>>4)
			{
			case ITEM_EXPLODE:
				if(bonus_explode(i)) re=TRUE;
				levBonuses++;
				break;
			case ITEM_COLOR:
				if(bonus_color(fld[i]&7)) re=TRUE;
				levBonuses++;
				break;
			}
			fld[i]=0;
		}
	}

	return re;
}



u8 drop_items(void)
{
	u8 i,j,pp;
	u8 move,stop;

	move=FALSE;
	stop=FALSE;

	gemsScreenCnt=0;

	for(i=0;i<8*8;i++)
	{
		if((fld[i]>>4)==ITEM_GEM) gemsScreenCnt++;
		clr[i]=0;
	}

	for(i=0;i<8;i++)
	{
		pp=7*8+i;
		for(j=0;j<7;j++)
		{
			if(!fld[pp]&&fld[pp-8])
			{
				fld[pp]=fld[pp-8];
				fld[pp-8]=0;
				clr[pp]=1;
			}
			pp-=8;
		}
		if(!fld[pp])
		{
			fld[pp]=generate_item();
			clr[pp]=1;
			fldpcol[pp]=TRUE;
			move=TRUE;
		}
		else
		{
			if(fldpcol[pp])
			{
				fldpcol[pp]=FALSE;
				stop=TRUE;
			}
		}
	}

	if(!fldInit&&stop) sfx_drop();

	return move;
}



u8 check_moves(void)
{
	u8 i,j,pp,item;

	hintAX=255;

	for(i=0;i<8*8;i++) fldchk[i]=fld[i]&7;

	pp=0;

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
			item=fldchk[pp];

			if(j<7)
			{
				if(fldchk[pp+1]==item)
				{
					if(j>1)
					{
						if(fldchk[pp-2]==item)
						{
							hintAX=j-1;
							hintAY=i;
							hintBX=j-2;
							hintBY=i;
							return TRUE;
						}
					}
					if(j<5)
					{
						if(fldchk[pp+3]==item)
						{
							hintAX=j+2;
							hintAY=i;
							hintBX=j+3;
							hintBY=i;
							return TRUE;
						}
					}
					if(j>0)
					{
						if(i>0)
						{
							if(fldchk[pp-8-1]==item)
							{
								hintAX=j-1;
								hintAY=i;
								hintBX=j-1;
								hintBY=i-1;
								return TRUE;
							}
						}
						if(i<7)
						{
							if(fldchk[pp+8-1]==item)
							{
								hintAX=j-1;
								hintAY=i;
								hintBX=j-1;
								hintBY=i+1;
								return TRUE;
							}
						}
					}
					if(j<6)
					{
						if(i>0)
						{
							if(fldchk[pp-8+2]==item)
							{
								hintAX=j+2;
								hintAY=i;
								hintBX=j+2;
								hintBY=i-1;
								return TRUE;
							}
						}
						if(i<7)
						{
							if(fldchk[pp+8+2]==item)
							{
								hintAX=j+2;
								hintAY=i;
								hintBX=j+2;
								hintBY=i+1;
								return TRUE;
							}
						}
					}
				}
				else
				{
					if(j<6)
					{
						if(fldchk[pp+2]==item)
						{
							if(i>0)
							{
								if(fldchk[pp-8+1]==item)
								{
									hintAX=j+1;
									hintAY=i;
									hintBX=j+1;
									hintBY=i-1;
									return TRUE;
								}
							}
							if(i<7)
							{
								if(fldchk[pp+8+1]==item)
								{
									hintAX=j+1;
									hintAY=i;
									hintBX=j+1;
									hintBY=i+1;
									return TRUE;
								}
							}
						}
					}
				}
			}

			if(i<7)
			{
				if(fldchk[pp+8]==item)
				{
					if(i>1)
					{
						if(fldchk[pp-16]==item)
						{
							hintAX=j;
							hintAY=i-1;
							hintBX=j;
							hintBY=i-2;
							return TRUE;
						}
					}
					if(i<5)
					{
						if(fldchk[pp+24]==item)
						{
							hintAX=j;
							hintAY=i+2;
							hintBX=j;
							hintBY=i+3;
							return TRUE;
						}
					}
					if(i>0)
					{
						if(j>0)
						{
							if(fldchk[pp-8-1]==item)
							{
								hintAX=j;
								hintAY=i-1;
								hintBX=j-1;
								hintBY=i-1;
								return TRUE;
							}
						}
						if(j<7)
						{
							if(fldchk[pp-8+1]==item)
							{
								hintAX=j;
								hintAY=i-1;
								hintBX=j+1;
								hintBY=i-1;
								return TRUE;
							}
						}
					}
					if(i<6)
					{
						if(j>0)
						{
							if(fldchk[pp+16-1]==item)
							{
								hintAX=j;
								hintAY=i+2;
								hintBX=j-1;
								hintBY=i+2;
								return TRUE;
							}
						}
						if(j<7)
						{
							if(fldchk[pp+16+1]==item)
							{
								hintAX=j;
								hintAY=i+2;
								hintBX=j+1;
								hintBY=i+2;
								return TRUE;
							}
						}
					}
				}
				else
				{
					if(i<6)
					{
						if(fldchk[pp+16]==item)
						{
							if(j>0)
							{
								if(fldchk[pp+8-1]==item)
								{
									hintAX=j;
									hintAY=i+1;
									hintBX=j-1;
									hintBY=i+1;
									return TRUE;
								}
							}
							if(j<7)
							{
								if(fldchk[pp+8+1]==item)
								{
									hintAX=j;
									hintAY=i+1;
									hintBX=j+1;
									hintBY=i+1;
									return TRUE;
								}
							}
						}
					}
				}
			}
			pp++;
		}
	}

	return FALSE;
}



void field_init(u8 reinit)
{
	u8 i,j,pp,item,prev,cnt;

	fldInitPtr=0;
	fldInit=TRUE;

	if(reinit)
	{
		gemsScreenCnt=0;

		for(i=0;i<8*8;i++)
		{
			if((fld[i]>>4)==ITEM_GEM) gemsScreenCnt++;
			fldinit[i]=fld[i];
		}
	}
	else
	{
		gemsScreenCnt=gemsScreenMax;
	}

	while(1)
	{
		pp=0;

		while(1)
		{
			for(i=0;i<8;i++)
			{
				prev=0;
				cnt=0;
				for(j=0;j<8;j++)
				{
					while(1)
					{
						item=generate_item()&7;
						fld[pp]=item;
						if(item==prev)
						{
							cnt++;
							if(cnt>2) continue;
						}
						else
						{
							prev=item;
							cnt=1;
						}
						break;
					}
					pp++;
				}
			}
			if(find_lines())
			{
				remove_lines();
				while(drop_items());
			}
			else
			{
				break;
			}
		}

		if(check_moves()) break;
	}

	if(!reinit)
	{
		for(i=0;i<8*8;i++)
		{
			fldinit[i]=fld[i];
			fld[i]=0;
		}
	}
	else
	{
		for(i=0;i<8*8;i++)
		{
			fldinit[i]=(fldinit[i]&0xf0)|fld[i];
			fld[i]=0;
		}
	}
	for(i=8*8;i<9*8;i++)
	{
		fld[i]=0;
		clr[i]=0;
	}
	for(i=0;i<8;i++) fldpcol[i]=TRUE;

	fldInit=FALSE;
}



void level_init(u8 lev)
{
	u8 pp;

	pp=(lev-1)<<3;

	itemTypes=levData[pp++];
	timeM=levData[pp++]+(difficulty?0:1);
	timeS=levData[pp++];
	gemsTotal=levData[pp++];
	gemsFreq=levData[pp++];
	gemsScreenMax=levData[pp++];
	hintTime=levData[pp++];
	bonusActive=levData[pp++];

	itemCnt=0;

	levItems=0;
	levCombo=0;
	levBonuses=0;

	bonusTimeCnt=0;
	bonusExplodeCnt=0;
	bonusColorCnt=0;
	bonusCollectCnt=0;

	field_init(FALSE);
}



void move_cursor(u8 i)
{
	curDX=0;
	curDY=0;
	if(i&UP   &&curY>0)  curDY=-1;
	if(i&DOWN &&curY<21) curDY=1;
	if(i&LEFT &&curX>0)  curDX=-1;
	if(i&RIGHT&&curX<21) curDX=1;
	if(curDX||curDY) curMove=3;
}



u8 exchange_items(u8 i)
{
	u8 cx,cy,dir;

	cx=curX/3;
	cy=curY/3;
	exchSrcOff=cy*8+cx;
	exchSrcItem=fld[exchSrcOff];
	exchDstOff=255;
	curEX=curX;
	curEY=curY;
	dir=0;

	if(cx>0&&i==LEFT)
	{
		exchDstOff=exchSrcOff-1;
		dir=RIGHT;
		curEX-=3;
	}
	if(cx<7&&i==RIGHT)
	{
		exchDstOff=exchSrcOff+1;
		dir=LEFT;
		curEX+=3;
	}
	if(cy>0&&i==UP)
	{
		exchDstOff=exchSrcOff-8;
		dir=DOWN;
		curEY-=3;
	}
	if(cy<7&&i==DOWN)
	{
		exchDstOff=exchSrcOff+8;
		dir=UP;
		curEY+=3;
	}

	if(exchDstOff!=255)
	{
		exchDstItem=fld[exchDstOff];
		fld[exchSrcOff]=0;
		fld[exchDstOff]=0;
		move_cursor(i);
		mode=MODE_EXCHANGE;
	}

	return dir;
}



void drop_all_scroll(void)
{
	u8 i;

	for(i=8*9-1;i>=8;i--)
	{
		fld[i]=fld[i-8];
	}
	for(i=0;i<8;i++) fld[i]=0;
}



void drop_all(void)
{
	u8 i;

	for(i=0;i<8*9;i++) clr[i]=TRUE;

	dropOff=0;
	dropAllCnt=0;
	mode=MODE_DROPALL;
	timeEnable=FALSE;
}



/*void draw_item(u8 x,u8 y,u8 type,u8 drop)
{
	u16 pp;
	u8 c;
	const u8 *t;

	pp=y*24+x;
	if(drop) pp=pp-dropOff*24;
	c=type>>3;
	type=type&7;
	if(sparkFrame<6&&drop) type=8+sparkFrame;
	t=tileList[type];

	if(type<8)
	{
		if(pp+2<24*24)
		{
			chr[pp+0]=t[0];
			chr[pp+1]=t[1];
			chr[pp+2]=t[2];
		}
		if(pp+26<24*24)
		{
			chr[pp+24]=t[3];
			chr[pp+25]=c?gemFrame:t[4];
			chr[pp+26]=t[5];
		}
		if(pp+50<24*24)
		{
			chr[pp+48]=t[6];
			chr[pp+49]=t[7];
			chr[pp+50]=t[8];
		}
	}
	else
	{
		if(t[0]!=255) chr[pp+0]=t[0];
		if(t[1]!=255) chr[pp+1]=t[1];
		if(t[2]!=255) chr[pp+2]=t[2];
		if(t[3]!=255) chr[pp+24]=t[3];
		if(t[4]!=255) chr[pp+25]=t[4];
		if(t[5]!=255) chr[pp+26]=t[5];
		if(t[6]!=255) chr[pp+48]=t[6];
		if(t[7]!=255) chr[pp+49]=t[7];
		if(t[8]!=255) chr[pp+50]=t[8];
	}
}*/



void draw_field(void)
{
	u8 i,j,cur;
	u8 curt[4];
	u16 pp;
/*
	pp=0;
	for(i=3;i<24+3+3;i+=3)
	{
		for(j=0;j<24;j+=3)
		{
			draw_item(j,i,fld[pp],flashType?0:clr[pp]);
			pp++;
		}
	}
*/
	draw_field_items();

	if(mode==MODE_EXCHANGE)
	{
		draw_item(curEX,curEY+3,exchDstItem,0);
		draw_item(curX,curY+3,exchSrcItem,0);
	}

	if(mode==MODE_CURMOVE||mode==MODE_CURHOLD)
	{
		if(hintCnt==hintTime)
		{
			if(hintAX<255)
			{
				chr[hintAY*3*24+hintAX*3+1+24*3]=252+hintAnim;
				chr[hintBY*3*24+hintBX*3+1+24*3]=252+hintAnim;
			}
		}
	}

	pp=0;

	if(mode!=MODE_DROPALL)
	{
		memset(TILES_ADR+2048,curCol,12);
		pp=curY*24+curX+24*3;
		if(flashType)
		{
			curt[0]=chr[pp+0];
			curt[1]=chr[pp+2];
			curt[2]=chr[pp+48];
			curt[3]=chr[pp+50];
		}
		cur=curAnim;
		if(cur==3) cur=1;
		chr[pp+0]=cur+0;
		chr[pp+2]=cur+3;
		chr[pp+48]=cur+6;
		chr[pp+50]=cur+9;
	}

	/*pp=0;
	for(i=3;i<24+3;i++)
	{
		for(j=0;j<24;j++)
		{
			print(j,i,chr[pp++]);
		}
	}*/
	print_fld();

	if(mode!=MODE_DROPALL&&flashType)
	{
		chr[pp+0]=curt[0];
		chr[pp+2]=curt[1];
		chr[pp+48]=curt[2];
		chr[pp+50]=curt[3];
	}
}



void draw_flash(void)
{
	u8 i,j,t,ptr;
	u8 *atr;
	u8 flash;

	ptr=0;

	for(i=0;i<8;i++)
	{
		atr=(u8*)22528+i*3*32;
		for(j=0;j<8;j++)
		{
			flash=FALSE;
			t=fld[ptr]&7;
			if(flashType&1)   if(t==1) flash=TRUE;
			if(flashType&2)   if(t==2) flash=TRUE;
			if(flashType&4)   if(t==3) flash=TRUE;
			if(flashType&8)   if(t==4) flash=TRUE;
			if(flashType&16)  if(t==5) flash=TRUE;
			if(flashType&32)  if(t==6) flash=TRUE;
			if(flashType&64)  if(t==7) flash=TRUE;
			if(flashType&128) if(fld[ptr]>>4==ITEM_GEM) flash=TRUE;
			if(flash)
			{
				*atr=64+7;
				*(atr+1)=64+7;
				*(atr+2)=64+7;
				*(atr+32)=64+7;
				*(atr+33)=64+7;
				*(atr+34)=7;
				*(atr+64)=7;
				*(atr+65)=7;
				*(atr+66)=7;
			}
			ptr++;
			atr+=3;
		}
	}
}



u8 title_screen(void)
{
	u8 i,cur,update;

	bb_depack(TITLE_PCK,SHADOW_SCR);
	screen_change(32,1);
	colorbar_effect();

	music_play(0);
	memset(SHADOW_SCR,0,0x1800);
	sfx_start();

	cur=0;
	update=TRUE;

	while(1)
	{
		vsync();

		if(update)
		{
			for(i=0;i<10;i++)
			{
				print2(11+i,18,48+i);
				print2(11+i,19,58+i);
			}

			memset(22528+18*32+15,1,2);
			memset(22528+19*32+15,1,2);
			memset(22528+18*32+11,cur?5:7,4);
			memset(22528+19*32+11,cur?5:7+64,4);
			memset(22528+18*32+17,!cur?5:7,4);
			memset(22528+19*32+17,!cur?5:7+64,4);

			update=FALSE;
		}

		i=poll_input();

		if(i&LEFT&&cur)
		{
			cur=0;
			sfx_hint();
			update=TRUE;
		}
		if(i&RIGHT&&!cur)
		{
			cur=1;
			sfx_hint();
			update=TRUE;
		}

		if(i&FIRE) break;
	}

	sfx_start();
	screen_change(32,0);

	return cur;
}



void level_screen(u8 w)
{
	u8 i,j;

	bb_depack(PANEL_PCK,SHADOW_SCR);

	make_screen_table(1);
	draw_gamestats(255);
	printlargetext(7,8,msgLevel);
	printlargenum16(14,8,level,2);
	printstr(4,12,"COLLECT    GEMS");
	print(12,12,gemsTotal/10+'0');
	print(13,12,gemsTotal%10+'0');

	switch(level)
	{
	case 3:
		printstr(3,16,"MAKE 3* COMBO FOR");
		printstr(5,17,"EXPLODE BONUS");
		break;
	case 5:
		printstr(3,16,"MAKE 4* COMBO FOR");
		printstr(6,17,"TIME  BONUS");
		break;
	case 7:
		printstr(3,16,"MAKE 5* COMBO FOR");
		printstr(4,17,"COLOR OUT BONUS");
		break;
	case 9:
		printstr(3,16,"MAKE 6* COMBO FOR");
		printstr(2,17,"COLLECT GEMS  BONUS");
		break;
	}

	screen_change(w,1);
	make_screen_table(0);
	draw_gamestats(255);

	music_play(1);

	cls_shadow(24);
	screen_change(24,0);
}



u8 timeout_screen(void)
{
	u8 i,j;

	darken_playfield();
	draw_gamestats(255);

	if(restarts)
	{
		printlargetext(7,9,msgTimeOut);
		printstr(7,14,"RESTARTS");
		print(16,14,'0'+restarts);
		restarts--;
		i=TRUE;
		music_play(3);
	}
	else
	{
		printlargetext(7,11,msgGameOver);
		i=FALSE;
		music_play(4);
	}

	wait_button();

	if(i) print(16,14,'0'+restarts);
	sfx_select();
	if(!soundEnable&&i) for(j=0;j<25;j++) vsync();

	return i;
}



void no_moves_screen(void)
{
	u8 i,j,off;

	darken_playfield();

	for(i=0;i<16;i++)
	{
		vsync();

		printlargetext(7,11,msgNoMoves);

		for(j=7;j<7+10;j++)
		{
			if(msgNoMoves[j-7]==32) continue;
			off=(j+i)&3;
			if(off==2) off=0;
			if(off==3) off=-1;
			char_scroll(j,11,off);
		}
		sfx_nomoves(400+((i&1)?0:20));
	}
}



void level_clear_screen(void)
{
	u16 s;

	bb_depack(PANEL_PCK,SHADOW_SCR);

	draw_gamestats(255);
	make_screen_table(1);
	draw_gamestats(255);
	printlargetext(6,7,msgLevelClear);
	printstr(4,12,"TOKENS");
	printstr(4,14,"BEST COMBO");
	printstr(4,16,"BONUSES");
	printnum16(19,12,levItems);
	printnum16(19,14,levCombo);
	printnum16(19,16,levBonuses);

	make_screen_table(0);
	screen_change(24,1);
	music_play(2);

	s=timeM*60+timeS;

	while(1)
	{
		draw_gamestats(STAT_SCORE|STAT_TIME);
		sfx_score();
		if(!s) break;
		if(s>=10)
		{
			s-=10;
			score+=difficulty?50:10;
			timeS-=10;
		}
		else
		{
			score+=s*(difficulty?5:1);
			timeS-=s;
			s=0;
		}
		if(timeS<0)
		{
			timeS+=60;
			if(timeM>0) timeM--; else timeS=0;
		}
	}

	wait_button();
	sfx_select();

	cls_shadow(24);
	screen_change(24,0);
}



void congratulations_screen(void)
{
	cls_shadow(32);
	screen_change(32,0);

	bb_depack(WELLDONE_PCK,SHADOW_SCR);
	make_screen_table(1);

	printstr(2,7,"YOU HAVE COMPLETED THE GAME!");
	printstr(9,8,"FINAL SCORE IS");
	printlargenum32(13,10,score,6);
	printstr(6,14,"TOKENS");
	printstr(6,15,"BEST COMBO");
	printstr(6,16,"BONUSES");
	printnum16(25,14,totalItems);
	printnum16(25,15,totalCombo);
	printnum16(25,16,totalBonuses);

	screen_change(32,1);
	music_play(5);
	sfx_select();

	cls_shadow(32);
	screen_change(32,0);
	make_screen_table(0);
}



u8 ingame_menu(void)
{
	u8 i,j,cur,done,down,update,cnt,show;
	u8 *p;

	p=(u8*)0x5800;

	for(i=0;i<24;i++)
	{
		for(j=0;j<24;j++) *p++=1;
		p+=8;
	}

	print(3,7,16);
	print(4,7,17);
	for(i=5;i<19;i++) print(i,7,18);
	print(19,7,19);
	print(20,7,20);

	for(i=8;i<16;i++)
	{
		for(j=4;j<20;j++) print(j,i,' ');
	}

	print(3,8,21);
	print(20,8,24);
	for(i=9;i<15;i++)
	{
		print(3,i,22);
		print(20,i,25);
	}
	print(3,15,23);
	print(20,15,26);

	print(3,16,27);
	print(4,16,28);
	for(i=5;i<19;i++) print(i,16,29);
	print(19,16,30);
	print(20,16,31);

	cur=0;
	done=FALSE;
	down=TRUE;
	update=TRUE;
	j=0;
	cnt=220;
	show=FALSE;

	printstr(6,9,"RESUME");
	printstr(6,10,"RESTART LEVEL");
	printstr(6,11,"SOUND FX");
	printstr(6,12,"QUIT TO MENU");
	printstr(6,14,"RESTARTS:");
	print(16,14,'0'+restarts);

	if(!restarts)
	{
		p=(u8*)22528+10*32+6;
		for(i=0;i<14;i++) *p++=7;
	}

	while(!done)
	{
		if(update)
		{
			printstr(15,11,soundEnable?"ON ":"OFF");
			update=FALSE;
		}

		vsync();

		for(i=0;i<4;i++) print(5,9+i,i==cur?cnt:' ');

		if(!show)
		{
			sfx_select();
			show=TRUE;
		}

		i=poll_input();

		if(!i&&down) down=FALSE;
		if(down)   i=0;
		if(i&UP)   i=UP;
		if(i&DOWN) i=DOWN;

		if(i&UP  &&cur>0)
		{
			cur--;
			if(!restarts&&cur==1) cur--;
			sfx_hint();
			down=TRUE;
		}
		if(i&DOWN&&cur<3)
		{
			cur++;
			if(!restarts&&cur==1) cur++;
			sfx_hint();
			down=TRUE;
		}

		if(i&FIRE||i&MENU)
		{
			down=TRUE;

			if(cur==2)
			{
				soundEnable^=TRUE;
				if(soundEnable) sfx_exchange(TRUE);
				update=TRUE;
			}
			else
			{
				done=TRUE;
			}
		}

		j=(j+1)&3;

		if(!j)
		{
			cnt++;
			if(cnt>=224) cnt=220;
		}
	}

	if(cur==1)
	{
		print(16,14,'0'+restarts-1);
		if(!soundEnable) for(i=0;i<25;i++) vsync();
	}

	sfx_select();

	return cur;
}



u8 game(void)
{
	u8 i,s,w,menu,done,recheck;
	u16 pp;
	u8 scoreRedraw,gemsRedraw;

	curX=3*3;
	curY=3*3;
	curAnim=0;
	curMove=0;
	curCol=64+7;
	mode=MODE_DROPITEMS;
	combo=0;
	dropOff=0;
	menu=FALSE;
	sparkFrame=6;
	gemFrame=12;
	hintCnt=0;

	scoreRedraw=FALSE;
	gemsRedraw=FALSE;
	msgDelay=0;
	flashType=0;
	flashCnt=0;

	level_init(level);

	if(showPanel)
	{
		showPanel=FALSE;
		w=32;
	}
	else
	{
		w=24;
	}

	timeRedraw=TRUE;
	timeMs=0;

	level_screen(w);

	timeEnable=TRUE;
	done=0;

	check_moves();

	soundClockCnt=0;
	recheck=FALSE;
	frameCnt=0;

	while(!done)
	{
		//vsync();
		draw_field();

		if(scoreRedraw)
		{
			draw_gamestats(STAT_SCORE);
			scoreRedraw=FALSE;
		}
		if(soundClock&&!(frameCnt&7)) timeRedraw=TRUE;
		if(timeRedraw)
		{
			draw_gamestats(STAT_TIME);
			timeRedraw=FALSE;
		}
		if(gemsRedraw)
		{
			draw_gamestats(STAT_GEMS);
			gemsRedraw=FALSE;
		}

		i=poll_input();

		if(!menu&&i&MENU)
		{
			timeEnable=FALSE;
			menu=TRUE;
			switch(ingame_menu())
			{
			case 0: break;
			case 1: done=DONE_RESTART; break;
			case 3: done=DONE_QUIT; break;
			}
			timeEnable=TRUE;
			continue;
		}
		if(!(i&MENU)) menu=FALSE;

		if(mode==MODE_CURMOVE||mode==MODE_CLEARLINES||mode==MODE_DROPITEMS)
		{
			if(!curMove)
			{
				if(mode==MODE_CURMOVE&&i&FIRE)
				{
					mode=MODE_CURHOLD;
					sfx_grip(TRUE);
				}
				else
				{
					move_cursor(i);
				}
			}
		}

		switch(mode)
		{
		case MODE_CURHOLD:
			if(!(i&FIRE))
			{
				mode=MODE_CURMOVE;
				sfx_grip(FALSE);
				break;
			}

			if(i&LEFT)  i=LEFT;
			if(i&RIGHT) i=RIGHT;
			if(i&UP)    i=UP;
			if(i&DOWN)  i=DOWN;

			exchDirM=exchange_items(i);
			if(exchDirM) sfx_exchange(TRUE);
			break;

		case MODE_EXCHANGE:
			if(!curMove)
			{
				fld[exchDstOff]=exchSrcItem;
				fld[exchSrcOff]=exchDstItem;
				if(find_lines())
				{
					combo=1;
					hintCnt=0;
					scoreRedraw=TRUE;
					gemsRedraw=TRUE;
					clear_lines();
				}
				else
				{
					if(exchDirM)
					{
						exchange_items(exchDirM);
						exchDirM=0;
						sfx_exchange(FALSE);
					}
					else
					{
						mode=MODE_CURHOLD;
					}
				}
			}
			break;

		case MODE_CLEARLINES:
			if(flashType)
			{
				vsync();
				draw_flash();
				vsync();
				if(flashCnt)
				{
					flashCnt--;
					if(!flashCnt)
					{
						remove_lines_pre();
						flashType=0;
					}
				}
				if(flashCnt) break;
				sparkFrame=-1;
			}

			if(sparkFrame<6)
			{
				sparkFrame++;
				if(sparkFrame==3) recheck=remove_lines();
				if(sparkFrame==1) sfx_match(800+combo*32,100);
				if(sparkFrame==4) sfx_match(800+combo*32,20);
				if(sparkFrame==6) sfx_match(800+combo*32,10);
				if(sparkFrame<=5) break;
			}

			if(recheck)
			{
				memcpy(clr,clrn,8*8);
				clear_lines();
				scoreRedraw=TRUE;
				gemsRedraw=TRUE;
			}
			else
			{
				mode=MODE_DROPITEMS;
			}
			break;

		case MODE_DROPITEMS:
			if(dropOff>0)
			{
				dropOff--;
				break;
			}
			if(!drop_items())
			{
				if(find_lines())
				{
					combo_increment();
					scoreRedraw=TRUE;
					gemsRedraw=TRUE;
					clear_lines();
				}
				else
				{
					if(combo>levCombo) levCombo=combo;
					if(combo>1)
					{
						draw_message(combo);
						score_add(5*combo);
						scoreRedraw=TRUE;
					}
					mode=MODE_CURMOVE;
					if(!check_moves())
					{
						no_moves_screen();
						cls_shadow(24);
						screen_change(24,0);
						field_init(TRUE);
						check_moves();
						mode=MODE_DROPITEMS;
					}
				}
			}
			else
			{
				dropOff=2;
			}
			break;

		case MODE_DROPALL:
			if(dropOff>0)
			{
				dropOff--;
				break;
			}
			if(dropAllCnt<8)
			{
				dropAllCnt++;
				dropOff=2;
				drop_all_scroll();
			}
			else
			{
				done=DONE_CLEAR;
			}
			break;
		}

		switch(mode)
		{
		case MODE_CURHOLD:
		case MODE_EXCHANGE:
			if(mode==MODE_CURHOLD)
			{
				curCol=frameCnt&1?64+5:64+7;
			}
			else
			{
				curCol=64+7;
			}
			curAnim=2;
			break;
		case MODE_CLEARLINES:
		case MODE_DROPITEMS:
			curCol=frameCnt&2?2+64:6+64;
			curAnim=0;
			break;
		default:
			curAnim=(curAnim+1)&3;
			curCol=64+7;
		}

		hintAnim=(hintAnim+1)&3;

		if(curMove)
		{
			curX+=curDX;
			curY+=curDY;
			if(mode==MODE_EXCHANGE)
			{
				curEX-=curDX;
				curEY-=curDY;
			}
			curMove--;
		}

		if(!(flashType&128))
		{
			gemFrame++;
			if(gemFrame>=16) gemFrame=12;
		}
		else
		{
			gemFrame=14;
		}

		if(mode==MODE_CURMOVE||mode==MODE_CURHOLD)
		{
			if(gemsTotal&&timeM==0&&timeS==0) done=DONE_TIMEOUT;
			if(!gemsTotal) drop_all();
			if(hintCnt<hintTime)
			{
				hintCnt++;
				if(hintCnt==hintTime) sfx_hint();
			}
		}

		if(timeM==0&&timeS<20) soundClock=TRUE; else soundClock=FALSE;

		if(msgDelay)
		{
			msgDelay--;
			if(!msgDelay) draw_message(0);
		}

		if(frameCnt&1) bonus_animation();
		frameCnt++;
	}

	draw_message(0);
	draw_gamestats(255);

	timeEnable=FALSE;
	soundClock=FALSE;

	return done;
}



void main(void)
{
	u8 page;

	cls_shadow(32);
	screen_change(32,0);

	soundEnable=TRUE;
	soundClock=FALSE;
	timeEnable=FALSE;
	set_interrupt();
	kempston_detect();
	make_screen_table(0);
	randomize();

	page=PAGE_TITLE;

	while(1)
	{
		switch(page)
		{
		case PAGE_TITLE:
			difficulty=title_screen();
			score=0;
			level=1;
			restarts=9;
			totalItems=0;
			totalCombo=0;
			totalBonuses=0;
			showPanel=TRUE;
			page=PAGE_GAME;
			break;
		case PAGE_GAME:
			switch(game())
			{
			case DONE_CLEAR:
				level_clear_screen();
				totalItems+=levItems;
				if(levCombo>totalCombo) totalCombo=levCombo;
				totalBonuses+=levBonuses;
				level++;
				if(level>10) page=PAGE_CLEAR;
				break;
			case DONE_TIMEOUT:
				if(!timeout_screen())
				{
					cls_shadow(32);
					screen_change(32,0);
					page=PAGE_TITLE;
				}
				else
				{
					cls_shadow(24);
					screen_change(24,0);
				}
				break;
			case DONE_RESTART:
				cls_shadow(24);
				screen_change(24,0);
				restarts--;
				break;
			case DONE_QUIT:
				cls_shadow(32);
				screen_change(32,0);
				page=PAGE_TITLE;
				break;
			}
			break;
		case PAGE_CLEAR:
			congratulations_screen();
			page=PAGE_TITLE;
			break;
		}
	}
}