;Stoker beeper music engine
;by Shiru (shiru@mail.ru) 08'10
;some inner loop improvements suggested by Alone Coder

	module stocker

OP_CALL	equ #cd

;HL=music data
;B=check keys while playing (1=yes 0=no)
;C=check kempston while playing (1=yes 0=no)
;D=looping mode (0=play in loop, 1=play once)
;IX=interrupt handler (0=disable)

play
	ld a,b
	ld (rowStart.checkKeys),a
	ld a,c
	or a
	jr z,$+4
	ld a,#1f
	ld (rowStart.checkKempston),a
	ld a,d
	ld (rowStart.loopMode),a
	ld a,ixl
	or ixh
	jr z,$+4
	ld a,OP_CALL
	ld (rowStart.int),a
	ld (rowStart.int+1),ix

	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ex de,hl
	ld bc,-192*2
	add hl,bc
	ld (insTable),hl
	ex de,hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (rowStart.ptr1),de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld (rowStart.ptr2),de

	ld hl,0
	ld de,0
	ld ix,0
	exx
	ld de,0
	ld (genLoop.slide1),de
	ld (genLoop.slide2),de
	xor a
	ld (rowStart.cnt1),a
	ld (rowStart.cnt2),a
	;ld (rowStart.drumlen),a
	ld (rowStart.detune1),a
	ld (rowStart.detune2),a

rowStart
.checkKeys=$+1
	ld a,0
	or a
	jr z,.l0
	xor a
	in a,(#fe)
	cpl
	and #1f
	jp nz,exit
	in a,(#1f)
.checkKempston=$+1
	and #1f
	jp nz,exit
.l0

.int
	nop
	nop
	nop

.cnt1=$+1
	ld a,0
	or a
	jr z,.la0
	dec a
	ld (.cnt1),a
	jp .la11
.la0
.ptr1=$+1
	ld hl,0
.la1
	ld a,(hl)
	inc hl
	cp 64			;pause
	jp nc,.la2
	ld (.cnt1),a
	jp .la10
.la2
	cp 185			;note and rest
	jr nc,.la3
	push hl
	push af
	cp 124
	jr c,$+4
	sub 60
	ld hl,noteTable-64*2
	ld b,0
	ld c,a
	add hl,bc
	add hl,bc
	ld e,(hl)
	inc hl
	ld d,(hl)
.detune1=$+1
	ld c,0
	ex de,hl
	add hl,bc
	ex de,hl
.iptr1=$+1
	ld hl,0
	pop af
	cp 124
	call c,setInstr1
	pop hl
	jp .la10
.la3
	cp 208			;instrument
	jr nc,.la4
	push hl
	ld hl,(insTable)
	ld b,0
	ld c,a
	add hl,bc
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld (.iptr1),hl
	call setInstr1
	pop hl
	jp .la1
.la4
	cp 251
	jr nz,.la5		;detune
	ld a,(hl)
	inc hl
	ld (.detune1),a
	jp .la1
.la5
	cp 252			;slide
	jr nz,.la6
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld (genLoop.slide1),bc
	jp .la1
.la6
	cp 253			;speed
	jr nz,.la7
	ld a,(hl)
	inc hl
	ld (.speed),a
	jp .la1
.la7
	cp 254			;loop position
	jr nz,.la8
	ld (.lptr1),hl
	jp .la1
.la8
	cp 255			;end of track
	jr nz,.la9
.lptr1=$+1
	ld hl,0
.loopMode=$+1
	ld a,0
	or a
	jp nz,exit
	jp .la1
.la9
	push de			;drums
	push hl
	ld b,0
	ld c,a
	ld hl,drumProc-224*2
	add hl,bc
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
.laret
	pop hl
	pop de
	;ld (.drumlen),a
	jp .la1
.la10
	ld (.ptr1),hl
.la11

	exx
.cnt2=$+1
	ld a,0
	or a
	jr z,.lb0
	dec a
	ld (.cnt2),a
	jp .lb11
.lb0
.ptr2=$+1
	ld hl,0
.lb1
	ld a,(hl)
	inc hl
	cp 64			;pause
	jp nc,.lb2
	ld (.cnt2),a
	jp .lb10
.lb2
	cp 185			;note and rest
	jr nc,.lb3
	push hl
	push af
	cp 124
	jr c,$+4
	sub 60
	ld hl,noteTable-64*2
	ld b,0
	ld c,a
	add hl,bc
	add hl,bc
	ld e,(hl)
	inc hl
	ld d,(hl)
.detune2=$+1
	ld c,0
	ex de,hl
	add hl,bc
	ex de,hl
.iptr2=$+1
	ld hl,0
	pop af
	cp 124
	call c,setInstr2
	pop hl
	jp .lb10
.lb3
	cp 208			;instrument
	jr nc,.lb4
	push hl
	ld hl,(insTable)
	ld b,0
	ld c,a
	add hl,bc
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld (.iptr2),hl
	call setInstr2
	pop hl
	jp .lb1
.lb4
	cp 251			;detune
	jr nz,.lb5
	ld a,(hl)
	inc hl
	ld (.detune2),a
	jp .lb1
.lb5
	cp 252			;slide
	jr nz,.lb6
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld (genLoop.slide2),bc
	jp .lb1
.lb6
	cp 254			;loop position
	jr nz,.lb7
	ld (.lptr2),hl
	jp .lb1
.lb7
	cp 255			;end of track
	jr nz,.lb10
.lptr2=$+1
	ld hl,0
	jp .lb1
.lb10
	ld (.ptr2),hl
.lb11

	ld c,#fe
	exx
	ld c,#fe

.speed=$+1
	ld a,0
/*.drumlen=$+1
	sub 0			;compensate for drum length
	jr nc,$+4
	ld a,1*/

rowLoop
	exa

.cnt1=$+1
	ld a,255
	or a
	jr z,.l1
	cp 255
	jr z,.l2
	dec a
	ld (.cnt1),a
	jr .l2
.l1
.pos1=$+1
	ld hl,0
	ld a,(hl)
	ld (genLoop.vol1),a
	inc hl
	ld a,(hl)
	ld (.cnt1),a
	inc hl
	ld (.pos1),hl
.l2

.cnt2=$+1
	ld a,255
	or a
	jr z,.l3
	cp 255
	jr z,.l4
	dec a
	ld (.cnt2),a
	jr .l4
.l3
.pos2=$+1
	ld hl,0
	ld a,(hl)
	ld (genLoop.vol2),a
	inc hl
	ld a,(hl)
	ld (.cnt2),a
	inc hl
	ld (.pos2),hl
.l4

	ld hl,#8810
	;exx
	;ld l,#10
	;exx
/*
genLoop
	add ix,de	;19
	jr nc,.l0	;7/12
	out (c),l	;12
.vol1=$+1
	ld b,16		;7
	djnz $		;~
	out (c),b	;12
.l0
	exx			;4
	add iy,de	;19
	jr nc,.l1	;7/12
	out (c),l	;12
.vol2=$+1
	ld b,16		;7
	djnz $		;~
	out (c),b	;12
.l1
	exx			;4
	dec h		;4
	jp nz,genLoop	;10=74t min
*/
/*
genLoop
	xor a		;4
	add ix,de	;19
	jr nc,$+4	;7/12
.vol1=$+1
	or 0		;7
	exx			;4
	add hl,de	;15
	exx			;4
	jr nc,$+4	;7/12
.vol2=$+1
	or 0		;7
	jr z,.l0	;7/12
	out (c),l	;12
	ld b,a		;4
	djnz $		;~
	out (c),b	;12
.l0
	ld b,a		;4
	ld a,31		;7
	sub b		;4
	ld b,a		;4
	djnz $		;~
	dec h		;4
	jp nz,genLoop	;10=~506t
*/
genLoop
	add ix,de	;19
	sbc a,a		;4
.vol1=$+1
	and 0		;7
	ld b,a		;4
	exx			;4
	add hl,de	;15
	exx			;4
	sbc a,a		;4
.vol2=$+1
	and 0		;7
	or b		;4
	jr z,.l0	;7/12
	out (c),l	;12
	ld b,a		;4
	djnz $		;~
	out (c),b	;12
.l0
	cpl			;4
	add a,#1f+1	;7
	ld b,a		;4
	djnz $		;~
	dec h		;4
	jp nz,genLoop	;10=~516t

.slide1=$+1
	ld hl,0
	ld a,h
	or l
	jr z,.l2
	add hl,de
	ex de,hl
.l2

.slide2=$+1
	ld hl,0
	ld a,h
	or l
	jr z,.l3
	add hl,de
	ex de,hl
.l3

	exa
	dec a
	jp nz,rowLoop

	;ld (rowStart.drumlen),a

	jp rowStart

setInstr1
	xor a
	ld (rowLoop.cnt1),a
	ld (rowLoop.pos1),hl
	ret

setInstr2
	xor a
	ld (rowLoop.cnt2),a
	ld (rowLoop.pos2),hl
	ret

exit
	ret

drum1
	ld hl,0
	ld bc,22*256+16
.l0
	ld a,(hl)
	and c
	out (#fe),a
	inc hl
	ld a,110
	sub b
	sub b
	ld e,a
	and c
	out (#fe),a
	dec e
	jr nz,$-1
	djnz .l0
	ld a,2
	jp rowStart.laret

drum2
	ld hl,0
	ld b,255
.l0
	ld a,(hl)
	inc hl
	and 16
	out (#fe),a
	xor a
	nop
	nop
	nop
	dec b
	out (#fe),a
	jr nz,.l0
	ld a,1
	jp rowStart.laret

drum3
	ld hl,0
	ld bc,15*256+30
.l0
	ld a,(hl)
	and 16
	inc hl
	out (#fe),a
	ld a,(hl)
	and 127
	add a,c
	dec a
	jr nz,$-1
	out (#fe),a
	ld a,c
	dec a
	jr nz,$-1
	inc hl
	ld a,c
	add a,8
	ld c,a
	djnz .l0
	ld a,3
	jp rowStart.laret

drum4
	ld b,40
	ld hl,256
	xor a
.l0
	xor 16
	out (#fe),a
	ld d,h
	ld e,l
	dec e
	jr nz,$-1
	dec d
	jr nz,$-4
	ld de,4
	add hl,de
	djnz .l0
	ld a,3
	jp rowStart.laret

noteTable
	dw 315,334,354,375,398,421,446,473,501,531,562,596
	dw 631,669,709,751,796,843,893,946,1003,1062,1125,1192
	dw 1263,1339,1418,1503,1592,1687,1787,1893,2006,2125,2251,2385
	dw 2527,2678,2837,3006,3184,3374,3574,3787,4012,4251,4503,4771
	dw 5055,5356,5674,6012,6369,6748,7149,7574,8025,8502,9007,9543
	dw 0

drumProc
	dw drum1,drum2,drum3,drum4

insTable
	dw 0

	endmodule