    device zxspectrum48

    org #8000

begin
	di
	ld hl,scrpacked
	ld de,#c000
	call depack
	ld hl,#4000
	ld de,#4001
	ld bc,#17ff
	ld (hl),l
	ldir
	ld hl,#c000+6144
	ld bc,768
	ldir
	call screenchange

	ei
	xor a
.l0
	push af
	halt

	cp 32
	jr nc,.l2
	ld hl,#5800
	ld b,0
	ld c,a
	add hl,bc
	ld b,24
	ld de,32
.l1
	set 6,(hl)
	add hl,de
	djnz .l1

.l2
	cp 8
	jr c,.l4
	sub 8
	ld hl,#5800
	ld b,0
	ld c,a
	add hl,bc
	ld ix,#d800
	add ix,bc
	ld b,24
	ld de,32
.l3
	ld a,(ix)
	ld (hl),a
	add hl,de
	add ix,de
	djnz .l3

.l4
	pop af
	inc a
	cp 40
	jr c,.l0

	di
	ld a,(#5b5c)
	or 16
	ld (#5b5c),a
	ld bc,#7ffd
	out (c),a
	ld hl,10072
	exx
	ei
	ret

;BitBuster depacker, originally by Arjan Bakker

depack

	inc hl
	inc hl
	inc hl
	inc hl

	ld a,128
	exx
	ld de,1
	exx

depack_loop
	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi
	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi
	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi
	jp depack_loop

output_compressed
	ld c,(hl)
	inc	hl

output_match
	ld b,0
	bit	7,c
	jr z,output_match1

	call GET_BIT_FROM_BITSTREAM
	rl b
	call GET_BIT_FROM_BITSTREAM
	rl b
	call GET_BIT_FROM_BITSTREAM
	rl b
	call GET_BIT_FROM_BITSTREAM

	jp c,output_match1
	res	7,c

output_match1
	inc	bc
	exx
	ld h,d
	ld l,e
	ld b,e

get_gamma_value_size
	exx
	call GET_BIT_FROM_BITSTREAM
	exx
	jr nc,get_gamma_value_size_end
	inc	b
	jp get_gamma_value_size

get_gamma_value_bits
	exx
	call GET_BIT_FROM_BITSTREAM
	exx
	adc	hl,hl

get_gamma_value_size_end
	djnz get_gamma_value_bits

get_gamma_value_end
	inc	hl
	exx
	ret c
	push hl
	exx
	push hl
	exx
	ld h,d
	ld l,e
	sbc	hl,bc
	pop	bc
	ldir
	pop	hl

	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi
	call GET_BIT_FROM_BITSTREAM
	jp c,output_compressed
	ldi

	jp depack_loop

GET_BIT_FROM_BITSTREAM
	add	a,a
	ret nz
	ld a,(hl)
	inc	hl
	rla
	ret



;screen change effect

screenchange
	ld b,8
.l0
	;halt
	push bc
	ld hl,#c000
	ld de,#4000
	ld b,192
.l1
	push bc
	ld b,16
	bit 0,h
	jr z,.l3
.l2
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	djnz .l2
	jr .l4
.l3
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	djnz .l3
.l4
	dec l
	inc hl
	dec e
	inc de
	pop bc
	dec b
	jp nz,.l1
	pop bc
	dec b
	jp nz,.l0

	ret



scrpacked
	incbin "screen.scr.pck"

end

    display /d,end-begin
    savebin "screen.bin",begin,end-begin