#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
    FILE *file;
    int i,j,len,size;
    unsigned char bin[65536];
    unsigned char tap[65536+19+2+2+2];
    char name[10],oname[MAX_PATH];
    unsigned char csum;

    if(argc<2)
    {
        printf("BIN2TAP by Shiru (shiru@mail.ru) 17.08.10\n");
        printf("Usage: bin2tap filename.ext [filename.tap]\n");
        return 0;
    }
  
    strcpy(oname,argv[1]);

    file=fopen(argv[1],"rb");
    if(!file) return 1;
    
    fseek(file,0,SEEK_END);
    size=ftell(file);
    fseek(file,0,SEEK_SET);
    
    if(size>65536)
    {
        fclose(file);
        return 1;
    }
    
    fread(bin,size,1,file);
    fclose(file);
    
    argv[1][strlen(argv[1])-4]=0;
    i=strlen(argv[1])-1;
    while(i)
    {
        if(argv[1][i]=='\\'||argv[1][i]=='/')
        {
            i++;
            break;
        }
        i--;
    }

    len=strlen(argv[1])-i;
    if(len>10) len=10;
    memset(name,32,10);
    for(j=0;j<len;j++) name[j]=argv[1][i++];

    tap[0]=19;//size of header
    tap[1]=0;

    tap[2]=0;//flag
    tap[3]=3;//code type
    memcpy(&tap[4],name,10);//name
    tap[14]=size&255;//size of data
    tap[15]=size>>8;
    tap[16]=0;//parameter 1
    tap[17]=0;
    tap[18]=0;//parameter 2
    tap[19]=0;

    csum=0;
    for(i=2;i<20;i++) csum^=tap[i];
    
    tap[20]=csum;//checksum of the header
    
    tap[21]=(size+2)&255;//size of data
    tap[22]=(size+2)>>8;
    tap[23]=0xff;//flag
    memcpy(&tap[24],bin,size);

    csum=0;
    for(i=23;i<23+size+1;i++) csum^=tap[i];
    
    tap[24+size]=csum;//checksum of the data

    if(argc<3)
    {
        oname[strlen(oname)-3]='t';
        oname[strlen(oname)-2]='a';
        oname[strlen(oname)-1]='p';
    }
    else
    {
        strcpy(oname,argv[2]);
    }

    file=fopen(oname,"wb");
    fwrite(tap,size+19+2+2+2,1,file);
    fclose(file);

    return 0;
}
